package
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import flash.ui.Mouse;
	import flash.utils.Timer;
	
	import org.flixel.*;
	import org.flixel.FlxSprite;
	import org.flixel.FlxState;
	import org.flixel.FlxU;
	import org.osmf.layout.AbsoluteLayoutFacet;
	
	public class EndState extends FlxState
	{
		public var t:Number;
		public var s:FlxSprite;
		override public function create():void
		{			
			FlxG.playMusic(TitleState.SndEndMusic);
			t=0;
			s = new FlxSprite(0,0);
			s.createGraphic(FlxG.width,FlxG.height,0,true);
			this.add(s);
		}
		
		public var rate:Number=10;
		public var rectsize:Number=10;
		
		override public function update():void
		{
			t+=FlxG.elapsed;
			s._pixels.fillRect(s._pixels.rect,0xff000000);
			for (var i:Number=0;i<1;i+=0.01)
			{
				var tx:Number = FlxG.width/2+(FlxG.width/2)*Math.cos(i*100+rate*t)*i;
				var ty:Number = FlxG.height/2+(FlxG.height/2)*Math.sin(i*100+rate*t)*i;
				s._pixels.fillRect(new Rectangle(tx-rectsize/2,ty-rectsize/2,rectsize,rectsize),Math.random()*0xffffffff);
			}
			s.resetHelpers();
		}
		
	}
}