package
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import flash.ui.Mouse;
	import flash.utils.Timer;
	
	import org.flixel.*;
	import org.flixel.FlxSprite;
	import org.flixel.FlxState;
	import org.flixel.FlxU;
	import org.osmf.layout.AbsoluteLayoutFacet;
	
	public class TitleState extends FlxState
	{
//		[Embed(source = "data/pattern1.png")] public static var ImgPattern:Class;

		[Embed(source = "data/bg.png")] private var ImgBg:Class;
		[Embed(source = "data/bar2.png")] private var ImgBar:Class;
		[Embed(source = "data/blip.png")] private var ImgBlip:Class;
		[Embed(source = "data/player.png")] private var ImgPlayer:Class;
		[Embed(source = "data/music.mp3")] public static var SndMusic:Class;
		[Embed(source = "data/endmusic.mp3")] public static var SndEndMusic:Class;
		[Embed(source = "data/click.mp3")] public static var SndClick:Class;
		public var background:FlxSprite;
		
		public static const xtiles:int = 10;
		public static const ytiles:int = 10;
		public const xmarginl:int = 10;
		public const xmarginr:int = 70;
		public const ymargin:int = 10;
		public var tilewidth:int;
		public var tileheight:int;
		
		public var screendat:FlxGroup;			
		
		public var prompttexts:Vector.<FlxText>;
		public var gridstate:GridState;
		public var backedup:GridState;
		
		public var newpoints:int;
		
		public var timertext:Vector.<TimerText>;
		
		public var flavourtxt:String;
		
		public var bars:Vector.<FlxSprite>;
		
		public static function trim( s:String ):String
		{
			return s.replace( /^([\s|\t|\n]+)?(.*)([\s|\t|\n]+)?$/gm, "$2" );
		}		
		
		private function loadLevel() : void
		{
			/*
			var s:String;
			switch (FlxG.level)
			{
				case 0:
					s = new TxtLevel1();
					break;
				case 1:
					s = new TxtLevel2();
					break;
				case 2:
					s = new TxtLevel3();
					break;
				case 3:
					s = new TxtLevel4();
					break;
				case 4:
					s = new TxtLevel5();
					break;
				case 5:
					s = new TxtLevel6();
					break;
				case 6:
					s = new TxtLevel7();
					break;
				case 7:
					s = new TxtLevel8();
					break;
				case 8:
					s = new TxtLevel9();
					break;
				case 9:
					s = new TxtLevel10();
					break;
				case 10:
					s = new TxtLevel11();
					break;
				case 11:
					s = new TxtLevel12();
					break;
				case 12:
					s = new TxtLevel13();
					break;
				case 13:
					s = new TxtLevel14();
					break;
				case 14:
					s = new TxtLevel15();
					break;
				case 15:
					s = new TxtLevel16();
					break;
				case 16:
					s = new TxtLevel17();
					break;
				case 17:
					s = new TxtLevel18();
					break;
				case 18:
					s = new TxtLevel19();
					break;
				case 19:
					s = new TxtLevel20();
					break;
			}
			
			
			tiles = new Vector.<Vector.<int>>();
			
			for(var i:int=0;i<xtiles;i++)
			{
				tiles.push(new Vector.<int>());
				for (j=0;j<ytiles;j++)
				{
					tiles[i].push(2);
				}
			}
			
			var rows:Array = s.split("\n");
			for(i=0;i<rows.length;i++)
			{
				var cols:Array = rows[i].split(",");
				for (var j:int=0;j<cols.length;j++)
				{					
					cols[j]=trim(cols[j]);
					
					switch(cols[j].charAt(0))
					{
						case 'P':
							px=j;
							py=i;
							tiles[j][i]=0;
							break;
						case 'F':
							fx=j;
							fy=i;
							tiles[j][i]=0;
							break;
						default:
							tiles[j][i] = int(cols[j]);
							break;
					}
				}
				tiles[px][py]=0;
				tiles[fx][fy]=0;
			}*/
			var dim:int = 3;

			var grids:Vector.<GridState> = new Vector.<GridState>();
			var mindepths:Vector.<Number> = new Vector.<Number>();
			var gametrees:Vector.<GameTreeLite> = new Vector.<GameTreeLite>();
			
			/*for (var i:int=0;i<10;i++)
			{
				gridstate = new GridState(dim,dim,dim*dim/2);
				var gtl:GameTreeLite = new GameTreeLite(gridstate);
				grids.push(gridstate);
				mindepths.push(gtl.mindepth());
			}*/
			
			/*
			var found:Boolean=false;
			while (!found)
			{
				gridstate = new GridState(dim,dim,dim*dim/2);
				gridstate.grid = GridState.randomGrid(dim,dim,dim*dim/2);
				
				
				var index:IntPoint=null;
				
				for (var i:int=0;i<dim;i++)
				{	
					for (var j:int=0;j<dim;j++)
					{						
						var thisgrid:GridState = gridstate.copyGrid();
						thisgrid.pos = new IntPoint(Math.random()*dim,Math.random()*dim);
						thisgrid.grid[thisgrid.pos.x][thisgrid.pos.y] = 0;
						var longestpath:Vector.<IntPoint> = GameTreeLite.FindLongestPath(thisgrid);
						if (longestpath.length<dim*dim)
						{
							continue;
						}
						else
						{
							var uniqueElems:Vector.<IntPoint> = getUniqueValuesIntPoint(longestpath);
							if (uniqueElems.length>dim*dim)
							{
								trace("ERRRRRROR123");
							}
							else if (uniqueElems.length==dim*dim)
							{
								trace("found");
								index = new IntPoint(i,j);
							}
							else
							{
								trace("not found");
							}
							/*
							var gtl:GameTreeLite = new GameTreeLite(thisgrid);
							gametrees.push(gtl);
							var deadends:int = gtl.deadends();
							var maxdepth:int = gtl.maxdepth();
							if (maxdepth==dim*dim)
							{
								index = new IntPoint(i,j);													
							}
							trace("NUMBER " + i.toString()+","+j.toString());
							trace("depth\t"+gtl.depth().toString());
							trace("mindepth\t"+gtl.mindepth().toString());
							trace("maxdepth\t"+gtl.maxdepth().toString());
							trace("dead ends\t"+deadends.toString());
							//grids.push(gridstate);
							//mindepths.push(gtl.mindepth());
							*//*
						}
					}
				}
				
				if (index!=null)
				{
					trace("choose " + index.x.toString()+","+index.y.toString() );
					gridstate.pos = index;
					gridstate.grid[gridstate.pos.x][gridstate.pos.y]=0;
					
					backedup=gridstate.copyGrid();
					found=true;
				}
				else
				{
					trace("nothing found :(");
				}
			}*/
			gridstate = new GridState(10,10,5);
			this.backedup=gridstate.copyGrid();
		}
		
		private var starttexts:Array = [
			"New level, new points!",
			"I like points",
			"Look at all of those lovely points!",
			"You got some points for me?"
			];
		
		private var cantDecide:Array = [
			"I can't decide",
			"What should I do?",
			"I am paralyzed by indecision!",
			"Hmm",
			"I can't rush about without reason",
			"Too many choices!",
			"You can press space to restart."
			];
		
		private var collecttexts:Array = [
			//0 points
			[
				"Aww, no points :(",
				"Where're my points?",
				"I want points!"
				],
			//1 point
			[
				"Aw shucks, just one point?",
				"I can do better than this.",
				"One lousy point"
				],
			//2 points
			[
				"Om nom nom nom",
				"Sweet",
				"Two juicy points"								
				],
			//3 points
			[
				"Hat trick!",
				"Three is a magic number",
				"These are mighty lovely points",	
				"I am an exquisite collector of points!",
				],
			//4 points
			[
				"Four points, and this is just the start",
				"Points are the best thing in the world",
				"Have you seen all my points?"
			],
			//5 points
			[
				"Five points is nothing to sniff at",
				"Five points means five happies",
				"happy happy happy"
			],
			//6 points
			[
				"Sextuple points!",
				"More points than any decent girl could wish for",
				"I have the best job in the world"
			],
			
			//7 points
			[
				"OMG SO MANY POINTS"
			],
			
		];
		public var thisscore:int;
		public var prompt_str:Array = [
			"HURRY",
			"RUSH",
			"QUICK QUICK",
			"BE QUICK",
			"FAST FAST FAST"
			];
		
		override public function create() : void
		{
			if (!FlxG.music)
			{
				FlxG.playMusic(SndMusic,0.5);
			}
				
			newpoints=-1;
			FlxG.level=5;
			super.create();			
			
			thisscore=0;
			
			tilewidth = (FlxG.width-(xmarginl+xmarginr))/xtiles;
			tileheight = (FlxG.height-2*ymargin)/ytiles;		
			
			timertext = new Vector.<TimerText>();
			
			background = new FlxSprite(0,0,ImgBg);
			this.add(background);
			
			screendat = new FlxGroup();
			this.add(screendat);
			
			bars = new Vector.<FlxSprite>();
			for (var i:int=0;i<46;i++)
			{
				var s:FlxSprite = new FlxSprite(507+Math.random()*5-2,23+10*i+Math.random()*5-2,ImgBar);
				bars.push(s);
				
				this.add(s);
			}
			loadLevel();	
			
			prompttexts=new Vector.<FlxText>;
			for (i=0;i<prompt_str.length;i++)
			{
				var txt:FlxText = new FlxText(0,0,FlxG.width,prompt_str[i]);
				this.prompttexts.push(txt);
				this.add(txt);
			}
			
			drawtiles();
		}
		
		public function drawtiles() : void
		{
			screendat.destroyMembers();
			for (var i:int =0;i<xtiles;i++)
			{
				for (var j:int=0;j<ytiles;j++)
				{
					var tilesprite:FlxSprite = new FlxSprite(xmarginl+tilewidth*i+2,ymargin+tileheight*j+2);
					tilesprite.createGraphic(tilewidth-4,tileheight-4,0x00000000,false,"T" + gridstate.grid[i][j].toString());
					var r:Number = 8;
					if (gridstate.grid[i][j]==1)
						r=0;
					
					for(var t:int=0;t<gridstate.grid[i][j];t++)
					{
						var pixx:int = (tilewidth-4)/2+r*Math.cos(Math.PI*2*t/gridstate.grid[i][j]);
						var pixy:int = (tileheight-4)/2+r*Math.sin(Math.PI*2*t/gridstate.grid[i][j]);
						tilesprite._pixels.fillRect(new Rectangle(pixx-2,pixy-2,4,4),0xffff0000);
					}
					tilesprite.resetHelpers();
					screendat.add(tilesprite);
					
				}
			
			}
			
			var player:FlxSprite = new FlxSprite(xmarginl+tilewidth*gridstate.pos.x+2,ymargin+tilewidth*gridstate.pos.y+2);
			player.createGraphic(tilewidth-4,tileheight-4,0x00000000,false,"player");
			player._pixels.fillRect(new Rectangle(5,5,tilewidth-4-10,tileheight-4-10),0xff0000ff);
			player.resetHelpers();
			screendat.add(player);
			
			/*
			var end:FlxSprite = new FlxSprite(xmargin+tilewidth*fx+2,ymargin+tilewidth*fy+2);
			end.createGraphic(tilewidth-4,tileheight-4,0x00000000,false,"player");
			end._pixels.fillRect(new Rectangle(5,5,tilewidth-4-10,tileheight-4-10),0xff00ff00);
			end.resetHelpers();
			screendat.add(end);
			*/
			
			var playerscore:FlxText = new FlxText(player.x+5,player.y+15,tilewidth-4-10,thisscore.toString());
			playerscore.alignment="center";
			playerscore.color=0xffffffff;
			screendat.add(playerscore);
			
			var playertext:FlxText = new FlxText(player.x+5+(tilewidth-4)/2-300,player.y+player.height+10,600,"");
			playertext.alignment="center";
			if (newpoints==-1)
			{				
				var rnew:int = Math.random()*starttexts.length;
				playertext.text = starttexts[rnew];
			}
			else if (newpoints==-2)
			{				
				rnew = Math.random()*cantDecide.length;
				playertext.text = cantDecide[rnew];
				FlxG.score/=2;
				FlxG.play(SndClick,2);
			}
			else
			{
				rnew = Math.random()*collecttexts[Math.min(newpoints,collecttexts.length-1)].length;
				playertext.text = collecttexts[Math.min(newpoints,collecttexts.length-1)][rnew];
				FlxG.score++;
				
				if (FlxG.score==44)
				{
					DoEnd();
				}
			}
			playertext.color=0xff000000;
			screendat.add(playertext);
			
			for (i=0;i<this.bars.length;i++)
			{
				bars[i].visible = i>=FlxG.score;
			}
			
		}
				
		public static function DoEnd():void
		{
			FlxG.state = new EndState();
		}
		
		public static function getUniqueValuesIntPoint(originalArray:Vector.<IntPoint>):Vector.<IntPoint>
		{
			var lookup:Array=new Array();
			var uniqueArr:Vector.<IntPoint>=new Vector.<IntPoint>();
			var num:int;
			for(var idx:int=0;idx < originalArray.length;idx++)
			{
				num=originalArray[idx].x*TitleState.xtiles+originalArray[idx].y;
				if(!lookup[num])
				{
					uniqueArr.push(originalArray[idx]);
					lookup[num]=true;
				}
			}
			return(uniqueArr);
		}
		
		override public function update() : void
		{
			
			for (i=0;i<this.prompttexts.length;i++)
			{
				prompttexts[i].x=-300+Math.random()*(FlxG.width+600);
				prompttexts[i].y=-300+Math.random()*(FlxG.height+600);
				prompttexts[i].size=Math.random()*50;
				prompttexts[i].color=Math.random()*0xffffffff;				
			}
			for (var i:int=0;i<timertext.length;i++)
			{
				//timertext[i].update();
				if (timertext[i].life>1)
				{
					this.defaultGroup.remove(timertext[i],true);
					timertext.splice(i,1);
					break;//1 per frame will do
				}
			}
			
			if (FlxG.keys.justPressed("ONE"))
			{
				Move(1);
			}
			else if (FlxG.keys.justPressed("TWO"))
			{
				Move(2);
			}
			if (FlxG.keys.justPressed("SPACE"))
			{
				if (FlxG.score>0)
				{
					FlxG.score--;
				}
				FlxG.state = new TitleState();	
			}
			/*if (FlxG.keys.justPressed("R"))
			{
				this.newpoints=-1;
				this.gridstate=this.backedup.copyGrid();
				this.drawtiles();
			}*/
			super.update();
		}
		
		private function Move(n:int):void
		{
			newpoints = gridstate.DoMove(n);
			
			if (newpoints>0)
			{
				thisscore+=newpoints;
				var txt:TimerText = new TimerText(xmarginl+tilewidth*gridstate.pos.x+tilewidth/2-50,ymargin+tileheight*gridstate.pos.y-10,100);
				txt.alignment="center";
				txt.text = "+" + newpoints.toString();
				txt.color=0xff000000;
				timertext.push(txt);
				this.add(txt);
			}
			
			drawtiles();						
		}
				
	}
	
	
}

class LookaheadStruct {
	public var targetdir:uint;
	public var valid:Boolean;
	public var score:int;
	public function LookaheadStruct( _dir:uint, _score:uint)
	{
		targetdir=_dir;
		score=_score;
	}
}

class IntPoint {
	public var x:int;
	public var y:int;
	public function IntPoint( _x:int, _y:int)
	{
		x=_x;
		y=_y;
	}	
	
	public static function compare(a:IntPoint, b:IntPoint):int{
		if (a.x<b.x)
			return -1;
		else if (a.x>b.x)
			return 1;
		else if (a.y<b.y)
			return -1;
		else if (a.y>b.y)
			return 1;
		else 
			return 0
		
	}
} 

import org.flixel.*;

class TimerText extends FlxText {
	public var life:Number;
	public function TimerText(X:Number,Y:Number,Width:uint,Text:String=null)
	{
		super(X,Y,Width,Text)
		life=0;
	}
	override public function update() : void
	{
		life+=FlxG.elapsed;
		//life goes from 0 to 1
		this.color = life*0xff*0x01000000 + this.color%0x01000000;
		super.update();
	}
}

class GameTreeLite {
	public var one:GameTreeLite;
	public var two:GameTreeLite;
	
	public function mindepth():Number
	{
		var d:Number=0;
		
		if (one!=null && two!=null)
		{
			d = Math.min(one.mindepth(),two.mindepth())+1;
		}
		else if (one!=null)
		{
			d = one.mindepth();//+1 not a choice
		}
		else if (two!=null)
		{
			d = two.mindepth();//+1 not a choice
		}
		
		return d;
		
	}
	
	
	public function deadends():Number
	{
		var d:Number=0;
		
		if (one!=null && two!=null)
		{
			d = one.deadends()+two.deadends();
		}
		else if (one!=null)
		{
			d = one.deadends();
		}
		else if (two!=null)
		{
			d = two.deadends();
		}
		else
		{
			d++;
		}
		
		return d;
		
	}
	
	public function maxdepth():Number
	{
		var d:Number=0;
		
		if (one!=null && two!=null)
		{
			d = Math.max(one.maxdepth(),two.maxdepth())+1;
		}
		else if (one!=null)
		{
			d = one.maxdepth();//+1 not a choice
		}
		else if (two!=null)
		{
			d = two.maxdepth();//+1 not a choice
		}
		
		return d;
		
	}
		
	public function depth():Number
	{
		var d:Number=0;
		if (one!=null)
		{
			d+=one.depth()+1;
		}
		if (two!=null)
		{
			d+=two.depth()+1;
		}
		
		d/=2;
		return d;
	}
	public function GameTreeLite(state:GridState)
	{
		var onestate:GridState = state.copyGrid();
		if (onestate.moveOne()>=0)
		{
			one=new GameTreeLite(onestate);
		}
		else
		{
			one=null;
		}
		
		var twostate:GridState = state.copyGrid();
		if (twostate.moveTwo()>=0)
		{
			two=new GameTreeLite(twostate);
		}
		else
		{
			two=null;
		}
	}
	
	public static function FindLongestPath(state:GridState):Vector.<IntPoint>
	{
		var result:Vector.<IntPoint> = new Vector.<IntPoint>();
		
		var one:Vector.<IntPoint>;
		var onestate:GridState = state.copyGrid();
		if (onestate.moveOne()>=0)
		{
			one=FindLongestPath(onestate);
		}
		else
		{
			one=new Vector.<IntPoint>();
		}

		var two:Vector.<IntPoint>;
		var twostate:GridState = state.copyGrid();
		if (twostate.moveTwo()>=0)
		{
			two=FindLongestPath(twostate);
		}
		else
		{
			two=new Vector.<IntPoint>();
		}
	
		if(one.length>two.length)
		{
			result=one;
		}
		else
		{
			result=two;
		}
		
		result.push(new IntPoint(state.pos.x,state.pos.y));
		
		return result;
	}
}


class GameTree {
	public var one:GameTree;
	public var two:GameTree;
	public var state:GridState;
	
	public function GameTree(State:GridState)
	{
		state=State;
		one=null;
		two=null;
	}
	
	public function PopulateChildren():void
	{
		if (one!=null || two!=null)
		{
			trace("f2j390f");
			return;
		}
		
		one = new GameTree(state.copyGrid());
		one.state.moveOne();
		two = new GameTree(state.copyGrid());
		two.state.moveTwo();
	}
}

class GridState {
	public var pos:IntPoint;
	public var grid:Vector.<Vector.<int>>;	
	
	public var dimensions:IntPoint;
	public var upperbound:int;
	
//	public function gameTreeImage():Vector.<Vector.<Boolean>>
//	{
//		var result:Vector.<Vector.<Boolean>> = new Vector.<Vector.<Boolean>>();
//		var path:Vector.<Boolean> = result.getDeepestPath
//		return result;
//	}
	
	public function moveOne():int
	{
		return DoMove(1);
	}
	
	public function moveTwo():int
	{
		return DoMove(2);
	}
	
	public function copyGrid():GridState
	{
		var g:GridState = new GridState(dimensions.x,dimensions.y,upperbound);
		g.pos = new IntPoint(pos.x,pos.y);
		g.grid = new Vector.<Vector.<int>>();
		for (var i:int = 0; i<grid.length;i++)
		{
			g.grid.push(new Vector.<int>());
			for (var j:int=0;j<grid[i].length;j++)
			{
				g.grid[i].push(grid[i][j]);
			}
		}		
		return g;
	}
	
	public function generateTree():GameTree
	{
		var g:GameTree = new GameTree(this);		
		return g;
	}
	
	public function GridState(Width:int,Height:int,Upperbound:int)
	{
		dimensions = new IntPoint(Width,Height);	
		upperbound=Upperbound;
		grid = randomGrid(dimensions.x,dimensions.y,upperbound);
		pos = new IntPoint(Math.random()*dimensions.x,Math.random()*dimensions.y);	
		grid[pos.x][pos.y]=0;
	}
	
	public static function randomGrid(width:int, height:int, upperbound:int):Vector.<Vector.<int> >
	{
		var result:Vector.<Vector.<int>> = new Vector.<Vector.<int>>();
		
		for(var i:int=0;i<TitleState.xtiles;i++)
		{
			result.push(new Vector.<int>());
			for (j=0;j<TitleState.ytiles;j++)
			{
				result[i].push(2);
			}
		}
		
		for (i=0;i<result.length;i++)
		{
			for (var j:int=0;j<result[i].length;j++)
			{
				if (i>=width || j>=height)
				{
					result[i][j]=0
				}
				else
				{
					result[i][j]=Math.random()*upperbound;
				}
			}
		}
		
		return result;
	}				
	
	public function DoMove(n:int):int
	{
		var dat:LookaheadStruct = lookahead(null,n);
		switch (dat.targetdir)
		{
			case FlxSprite.UP:
				pos.y--;
				break;
			case FlxSprite.DOWN:
				pos.y++;
				break;
			case FlxSprite.LEFT:
				pos.x--;
				break;					
			case FlxSprite.RIGHT:
				pos.x++;
				break;
			case FlxSprite.NODIR:
//				trace("no dir :(");
				break;
		}
		
		var score:int;
		if (dat.valid)
		{
			score = grid[pos.x][pos.y];
		}
		else
		{
			score = -2;
		}

		grid[pos.x][pos.y]=0;		
		return score;
	}
	
	public function lookahead(path : Vector.<IntPoint>, amount:int):LookaheadStruct //
	{
		if (path==null)
		{
			path = new Vector.<IntPoint>();
			path.push(new IntPoint(pos.x,pos.y));
		}
		
		var lastpoint:IntPoint = path[path.length-1];			
		
		var result:LookaheadStruct = new LookaheadStruct(FlxSprite.NODIR,0);
		if (amount>0)
		{
			//find max score
			//check not more than one point share the max
			
			var maxscore:int = -1;
			var maxcount:int = -1;
			var maxdir:int = -1;
			var maxvaliddir:Boolean = false;
			var maxindex:int = -1;
			for (var i:int=0;i<4;i++)
			{
				var point:IntPoint = new IntPoint(lastpoint.x,lastpoint.y);
				switch(i)
				{
					case FlxSprite.UP:
						point.y--;
						break;
					case FlxSprite.DOWN:
						point.y++;
						break;
					case FlxSprite.LEFT:
						point.x--;
						break;
					case FlxSprite.RIGHT:
						point.x++;
						break;
				}
				
				if (!boundedPoint(point))
					continue;
				
				path.push(point);
				var res:LookaheadStruct = lookahead(path,amount-1);
				path.pop();
				
				if (res.score>maxscore )
				{
					maxscore=res.score;
					maxcount=1;
					maxindex=i;
					maxdir=i;
					maxvaliddir=res.valid;
				}
				else if (res.score==maxscore)
				{
					maxcount++;
				}
				
			}
			
			if (maxindex>=0 && maxcount==1 && maxvaliddir==true)
			{
				result.targetdir=maxindex;
				result.valid=true;
				result.score=maxscore;
			}
			else
			{
				result.targetdir=FlxSprite.NODIR;
				result.valid=false;
				result.score=maxscore;
			}
		}
		else
		{
			result.targetdir=FlxSprite.NODIR;//it doesn't matter which one precisely, so long as it's a valid dir
			result.valid=true;
		}
		
		var toadd:int = grid[lastpoint.x][lastpoint.y];
		//if already have been there, don't increase score;
		for (i=0;i<path.length-1;i++)
		{
			if (path[i].x==lastpoint.x && path[i].y==lastpoint.y)
			{
				toadd=0;
				break;
			}
		}
		
		result.score+=toadd;
		
		return result;
	}
	
	private function boundedPoint(p:IntPoint):Boolean
	{
		return p.x>=0 && p.x<dimensions.x && p.y>=0 && p.y<dimensions.y;
	}
}